#include <iostream>
#include <queue>
using namespace std;
struct point
{
    int x,y;
};
bool operator<(point a, point b)
{
    if(a.y < b.y) return 1;
    if(a.y > b.y) return 0;
    if(a.x < b.x) return 1;
    return 0;
}
int n, t, m;
int ori;
bool ishor, isver;
queue<point> black;
priority_queue<point> ans;
point orient(point a, int o)
{
    point ret;
    if(o == 2) return a;
    if(o == 0)
    {
        ret.x = n-1-a.x;
        ret.y = n-1-a.y;
    }
    if(o == 3)
    {
        ret.x = n-1-a.y;
        ret.y = a.x;
    }
    if(o == 1)
    {
        ret.x = a.y;
        ret.y = n-1-a.x;
    }
    return ret;
}
point back_or(point a, int o)
{
    if(o == 2) return a;
    if(o == 0) return orient(a, o);
    if(o == 1) return orient(a, 3);
    if(o == 3) return orient(a, 1);
}
point fix(point a)
{
    point ret = a;
    if(ishor && isver) return orient(a, 0);
    if(ishor) ret.x = n-1-a.x;
    if(isver) ret.y = n-1-a.y;
    return ret;
}
point neg(point a)
{
    point ret;
    ret.x=-a.x;
    ret.y=-a.y;
    return ret;
}
int main()
{
    ori = 2;
    cin >> n >> t >> m;
    for(int i = 0; i < t; i ++)
    {
        point tmp;
        cin >> tmp.y >> tmp.x;
        tmp.x --;
        tmp.y --;
        black.push(tmp);
    }
    for(int i = 0; i < m; i ++)
    {
        int op;
        cin >> op;
        if(op == 1)
        {
            char w;
            cin >> w;
            if(w == 'L')
            {
                if(!ishor) ori --;
                else ori ++;
                //bool save = isver;
                //isver = ishor;
                //ishor = save;
            }
            if(w == 'R')
            {
                if(!isver) ori ++;
                else ori --;
                //bool save = isver;
                //isver = ishor;
                //ishor = save;
            }
            if(w == 'Q') ori += 2;
            if(w == 'V')
            {
                if(ori == 0 || ori == 2) ishor = 1-ishor;
                else isver = 1-isver;
            }
            if(w == 'H')
            {
                if(ori == 0 || ori == 2) isver = 1-isver;
                else ishor = 1-ishor;
            }
            if(ori == -1) ori = 3;
            ori %= 4;
        }
        if(op == 2)
        {
            point tm;
            cin >> tm.y >> tm.x;
            tm.y --;
            tm.x --;
            tm = fix(back_or((tm), ori));
            black.push(tm);
        }
        /*queue<point> cpy = black;
        while(!cpy.empty())
        {
            point tmp = orient(fix(cpy.front()), ori);
            cpy.pop();
            cout << " a " << tmp.y << " " << tmp.x << endl;
        }*/
    }
    while(!black.empty())
    {
        point tmp = orient(fix(black.front()),ori);
        //cout << tmp.y << "/" << tmp.x << endl;
        ans.push(neg(orient(fix(black.front()),ori)));
        //cout << "Pushing" << endl;
        black.pop();
    }
    int k;
    cin >> k;
    for(int i = 0; i < k && !ans.empty(); i ++)
    {
        //cout << " ll " << ans.top().y << ans.top().x <<endl;
        point tmp = ans.top();
        ans.pop();
        point tmp2;
        tmp2.x = 1;
        tmp2.y = 1;
        if(!ans.empty()) tmp2 = ans.top();
        if(tmp2.x == tmp.x && tmp2.y == tmp.y)
        {
            i --;
            ans.pop();
        }
        else cout << -tmp.y+1 << " " << -tmp.x+1 << endl;
    }
}
