#include <iostream>
using namespace std;
int n, a[(1<<20)], mod = 1000000007, cnt[(1<<20)];
long long fact[(1<<20)];
bool used[(1<<20)];

long long pow2 ( long long a, long long st ) {
    long long ret = 1;
    for ( ; st ; st /= 2 ) {
        if ( st &1 ) {
            ret *= a;
            ret %= mod;
        }

        a *= a;
        a %= mod;
    }
    return ret;
}

int main () {

    fact[0] = 1;
    for (int i= 1 ; i <= 1000000 ; i ++ ) {
        fact[i] = i*fact[i-1]%mod;
    }

    cin >> n;
    for ( int i = 1 ; i <= n ; i ++ ) {
        cin >> a[i];
    }
    long long ans = 1;
    for ( int i = 1 ; i <= n ; i ++ ) {
        int cc = 0, crr = i;
        for ( ; !used[crr] ; crr = a[crr] ) {
            cc ++;
            used[crr] = 1;
        }
        if ( cc ) {
            cnt[cc] ++;
        }
    }

    for ( int i = 1 ; i <= n ; i ++ ) {
        //cout << i << " : " << cnt[i] << " -> " << pow2( i, cnt[i] ) << "*" << fact[ cnt[i] ] << "\n";
        if ( cnt[i] ) {
            ans *= 1LL*pow2( i, cnt[i] );
            ans %= mod;
            ans *= fact[ cnt[i] ];
            ans %= mod;
        }
        ans %= mod;
    }
    cout << ans << "\n";
    return 0;
}
