#include <bits/stdc++.h>
#define endl '\n'

//#pragma GCC optimize ("O3")
//#pragma GCC target ("sse4")

using namespace std;
template<class T, class T1> void chkmin(T &x, const T1 &y) { if(x > y) x = y; }
template<class T, class T1> void chkmax(T &x, const T1 &y) { if(x < y) x = y; }
const int MAXN = (1 << 7);

int n, m, k, t;
set<pair<int, int> > st;

void read()
{
	cin >> n >> t >> m;
	for(int i = 0; i < t; i++)
	{
		int x, y;
		cin >> x >> y;
		st.insert({x, y});
	}
}

int rot, hor, ver;

pair<int, int> pref(int x, int y)
{
	for(int d = 0; d < (4 - rot); d++)
	{
		int new_x = y, new_y = n - x + 1;
		x = new_x, y = new_y;
	}
	
	if(hor) y = n - y + 1;
	if(ver) x = n - x + 1;
	
	return {x, y};
}

int tb[MAXN][MAXN];

void print_table()
{
	memset(tb, 0, sizeof(tb));
	rot = (4 - rot) % 4;
	swap(hor, ver);
	
	for(auto itt: st)
	{
		auto it = pref(itt.first, itt.second);
		tb[it.first][it.second] = 1;
	}
		
	for(int i = 1; i <= n; i++)
		for(int j = 1; j <= n; j++)
			cout << tb[i][j] << " \n"[j == n];
	
	
	swap(hor, ver);
	rot = (4 - rot) % 4;
}

void solve()
{
	rot = 0;
	hor = 0;
	ver = 0;
	
	for(int i = 0; i < m; i++)
	{
		int type;
		cin >> type;
		
		if(type == 1)
		{
			string q;
			cin >> q;
			if(q == "R") rot = (rot + 1) % 4;
			if(q == "L") rot = (rot + 3) % 4;
			if(q == "Q") rot = (rot + 2) % 4;
			if(q == "H") 
			{
				if(rot % 2 == 1) ver ^= 1; 
				else hor ^= 1;
			}
			
			if(q == "V") 
			{
				if(rot % 2 == 1) hor ^= 1;
				else ver ^= 1;
			}
		}
		else
		{
			int x, y;
			cin >> x >> y;
			pair<int, int> p = pref(x, y);
			x = p.first, y = p.second;
				
			//cout << "actual: " << x << " " << y << endl;
			
			if(st.find({x, y}) == st.end()) st.insert({x, y});
			else st.erase({x, y});
		}
		
		/*cout << "-------------------------" << endl;
		print_table();
		cout << "-------------------------" << endl;
		cout << endl << flush;*/
	}

	cin >> k; 
	
	rot = (4 - rot) % 4;
	swap(hor, ver);
	vector<pair<int, int> > answer;
	for(auto &it: st)
		answer.push_back(pref(it.first, it.second));
	
	sort(answer.begin(), answer.end());
	for(int i = 0; i < k; i++)
		cout << answer[i].first << " " << answer[i].second << endl;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	
	read();
	solve();
	return 0;
}

