# include <cstdio>
# include <vector>
# include <algorithm>

using namespace std;

const int MAX_N = 2e5 + 10;

int n;

pair <int, int> p[2][MAX_N];

pair <int, int> b[2 * MAX_N];

int id, xi;

long long cross (pair <long long, long long> x, pair <long long, long long> y)
{
    return x.first * y.second - x.second * y.first;
}

bool cmp (pair <int, int> x, pair <int, int> y)
{
    if (x.first == id && x.second == xi)
        return true;
    if (y.first == id && y.second == xi)
        return false;

    long long c = cross (
                         {p[x.first][x.second].first - p[id][xi].first, p[x.first][x.second].second - p[id][xi].second},
                         {p[y.first][y.second].first - p[id][xi].first, p[y.first][y.second].second - p[id][xi].second});
    return (c > 0);
}

int main ()
{
    int i;
    scanf ("%d", &n);
    for (i = 0; i < n; i ++)
    {
        scanf ("%d%d", &p[0][i].first, &p[0][i].second);
        if (p[0][i].second < p[id][xi].second || (p[0][i].second == p[id][xi].second && p[0][i].first < p[id][xi].first))
        {
            id = 0;
            xi = i;
        }
        b[i] = {0, i};
    }

    for (i = 0; i < n; i ++)
    {
        scanf ("%d%d", &p[1][i].first, &p[1][i].second);
        if (p[1][i].second < p[id][xi].second || (p[1][i].second == p[id][xi].second && p[1][i].first < p[id][xi].first))
        {
            id = 1;
            xi = i;
        }
        b[n + i] = {1, i};
    }

    sort (b, b + 2 * n, cmp);

    ///for (i = 0; i < 2 * n; i ++)
    ///    printf ("%d %d -> %d %d\n", b[i].first, b[i].second, p[b[i].first][b[i].second].first, p[b[i].first][b[i].second].second);

    printf ("%d\n", 2 * n - 1);

    int last[2] = {-1, -1};

    last[b[0].first] = b[0].second;

    vector <int> todo;

    if (!b[0].first)
    {
        for (i = 1; i < 2 * n; i ++)
        {
            if (b[i].first)
            {
                printf ("%d %d\n", b[0].second + 1, n + 1 + b[i].second);
                for (int j = 0; j < (int) todo.size (); j ++)
                    printf ("%d %d\n", todo[j] + 1, n + 1 + b[i].second);
                todo.clear ();
                last[1] = b[i].second;
            }
            else
            {
                if (last[1] == -1)
                    todo.push_back (b[i].second);
                else
                    printf ("%d %d\n", b[i].second + 1, n + 1 + last[1]);
            }
        }
    }
    else
    {
        for (i = 1; i < 2 * n; i ++)
        {
            if (!b[i].first)
            {
                printf ("%d %d\n", b[i].second + 1, n + 1 + b[0].second);
                for (int j = 0; j < (int) todo.size (); j ++)
                    printf ("%d %d\n", b[i].second + 1, n + 1 + todo[j]);
                todo.clear ();
                last[0] = b[i].second;
            }
            else
            {
                if (last[0] == -1)
                    todo.push_back (b[i].second);
                else
                    printf ("%d %d\n", last[0] + 1, n + 1 + b[i].second);
            }
        }
    }

    return 0;
}
/**
6
6 5
3 3
5 2
7 2
9 5
9 1
5 8
2 4
6 3
8 0
10 4
8 7
**/
