# include <cstdio>
# include <set>
# include <vector>
# include <string>
# include <algorithm>

using namespace std;

const int MAX_N = 1e5 + 10;
const int MAX_M = 1e5 + 10;

int n, m, t, k;

set <pair <int, int> > p;
vector <char> s;

inline string last2 ()
{
    string ff = "";
    ff = ff + s[s.size () - 2];
    ff = ff + s[s.size () - 1];
    return ff;
}

inline string last3 ()
{
    string ff = "";
    ff = ff + s[s.size () - 3];
    ff = ff + s[s.size () - 2];
    ff = ff + s[s.size () - 1];
    return ff;
}

void add (char c)
{
    int i;
    s.push_back (c);

    while (s.size () > 1)
    {
        string crr = last2 ();
        if (crr == "LR" || crr == "RL" || crr == "VV" || crr == "HH" || crr == "QQ")
        {
            s.pop_back ();
            s.pop_back ();
            continue;
        }
        if (crr == "QR" || crr == "RQ")
        {
            s.pop_back ();
            s.pop_back ();
            s.push_back ('L');
            continue;
        }

        if (crr == "QL" || crr == "LQ")
        {
            s.pop_back ();
            s.pop_back ();
            s.push_back ('R');
            continue;
        }

        if (crr == "QV" || crr == "VQ")
        {
            s.pop_back ();
            s.pop_back ();
            s.push_back ('H');
            continue;
        }

        if (crr == "QH" || crr == "HQ")
        {
            s.pop_back ();
            s.pop_back ();
            s.push_back ('V');
            continue;
        }

        if (crr == "HV" || crr == "VH")
        {
            s.pop_back ();
            s.pop_back ();
            s.push_back ('Q');
            continue;
        }

        if (s.size () > 2)
        {
            crr = last3 ();
            if (crr == "RHR" || crr == "LHL")
            {
                s.pop_back ();
                s.pop_back ();
                s.pop_back ();
                s.push_back ('H');
                continue;
            }

            if (crr == "RVR" || crr == "LVL")
            {
                s.pop_back ();
                s.pop_back ();
                s.pop_back ();
                s.push_back ('V');
                continue;
            }

            if (crr == "RVL" || crr == "LVR")
            {
                s.pop_back ();
                s.pop_back ();
                s.pop_back ();
                s.push_back ('H');
                continue;
            }

            if (crr == "LHR" || crr == "RHL")
            {
                s.pop_back ();
                s.pop_back ();
                s.pop_back ();
                s.push_back ('V');
                continue;
            }

        }

        break;
    }

    ///for (i = 0; i < (int) s.size (); i ++)
    ///    printf ("%c", s[i][0]);
}

inline pair <int, int> rot (pair <int, int> x, char c)
{
	if (c == 'R')
		return {x.second, n - x.first + 1};
	if (c == 'L')
		return {n - x.second + 1, x.first};
	if (c == 'Q')
		return {n - x.first + 1, n - x.second + 1};
	if (c == 'V')
		return {n - x.first + 1, x.second};
	if (c == 'H')
		return {x.first, n - x.second + 1};
	printf ("ahh\n");
	return {-1, -1};
}

inline pair <int, int> rev (pair <int, int> c)
{
    int i;
    for (i = s.size () - 1; i >= 0; i --)
    {
        ///printf ("r %d %d\n", c.first, c.second);
        if (s[i] == 'R')
        {
            c = rot (c, 'L');
            continue;
        }
        if (s[i] == 'L')
        {
            c = rot (c, 'R');
            continue;
        }
        if (s[i] == 'Q')
        {
            c = rot (c, 'Q');
            continue;
        }
        if (s[i] == 'H')
        {
            c = rot (c, 'H');
            continue;
        }
        if (s[i] == 'V')
        {
            c = rot (c, 'V');
            continue;
        }
    }

    return c;
}


int main ()
{
	int i, j, type;
	char tt;
	pair <int, int> c;

	scanf ("%d%d%d", &n, &m, &t);

	for (i = 1; i <= m; i ++)
	{
		scanf ("%d%d", &c.first, &c.second);
		p.insert (c);
	}

	for (i = 0; i < t; i ++)
	{
		scanf ("%d", &type);
		if (type == 1)
		{
			scanf (" %c", &tt);

			add (tt);
		}
		else
		{
			scanf ("%d%d", &c.first, &c.second);

			c = rev (c);
			///printf ("%d %d\n", c.first, c.second);

			if (p.find (c) != p.end ())
				p.erase (c);
			else
				p.insert (c);
		}
	}

	scanf ("%d", &k);

	vector <pair <int, int> > fp;

	for (set <pair <int, int> > :: iterator it = p.begin (); it != p.end (); it ++)
    {
        c = *it;
        for (i = 0; i < (int) s.size (); i ++)
            c = rot (c, s[i]);
        fp.push_back (c);
    }

    sort (fp.begin (), fp.end ());

    for (i = 0; i < k; i ++)
        printf ("%d %d\n", fp[i].first, fp[i].second);

	return 0;
}
