# include <cstdio>
# include <algorithm>

using namespace std;

const int MAX_N = 1e6 + 10;

const long long MOD = 1000000007;

int n;

int p[MAX_N];
int u[MAX_N];
int c[MAX_N];

int cnt;

void dfs (int x)
{
    while (1)
    {
        cnt ++;
        u[x] = true;
        if (!u[p[x]])
            x = p[x];
        else
            break;
    }
}

int main ()
{
    int i;
    scanf ("%d", &n);

    for (i = 1; i <= n; i ++)
        scanf ("%d", &p[i]);

    for (i = 1; i <= n; i ++)
    {
        cnt = 0;
        if (!u[i])
            dfs (i);
        c[cnt] ++;
    }

    long long ans = 1;

    for (i = 1; i <= n; i ++)
    {
        if (!c[i])
            continue;
        ans = (ans * i) % MOD;
        while (c[i])
        {
            ans = (ans * c[i]) % MOD;
            c[i] --;
        }
    }

    printf ("%lld\n", ans);

    return 0;
}
