#include<iostream>
#include<algorithm>
using namespace std;

int a[10000][10000],m,n,t,k;

void update(){
    for(int i=0;i<n;i++){
        for(int j=0;j<n;j++){
            if(a[i][j]!=2)continue;
            a[i][j]=1;
        }
    }
}

void swapCells(int x1,int y1,int x2,int y2){
    a[x1][y1]=a[x2][y2]!=0?2:0;
    a[x2][y2]=2;
}

void rotate90(char op){
    if(op=='R'){
        for(int i=0;i<n;i++){
            for(int j=0;j<n;j++){
                if(a[i][j]==0 or a[i][j]==2)continue;

                swapCells(i,j,j,n-1-i);
            }
        }
    }else{
        for(int i=0;i<n;i++){
            for(int j=0;j<n;j++){
                if(a[i][j]==0 or a[i][j]==2)continue;

                swapCells(i,j,n-1-j,i);
            }
        }
    }
    update();
}

void rotate180(){
    for(int i=0;i<n;i++){
        for(int j=0;j<n;j++){
            if(a[i][j]==0 or a[i][j]==2)continue;

            swapCells(i,j,n-1-i,j);
        }
    }
    update();
}

void rotateHV(char op){
    if(op=='H'){
        for(int i=0;i<n;i++){
            for(int j=0;j<n;j++){
                if(a[i][j]==0 or a[i][j]==2)continue;

              swapCells(i,j,i,n-1-j);
            }
        }
    }else{
        for(int i=0;i<n;i++){
            for(int j=0;j<n;j++){
                if(a[i][j]==0 or a[i][j]==2)continue;

              swapCells(i,j,n-1-i,j);
            }
        }
    }
    update();
}

int main(){
    char ch,ch1,ch2;
    int index1,index2,op;
    string s="";

    cin>>n>>t>>m;

    for(int i=0;i<t;i++){
        cin>>index1>>index2;
        a[index1-1][index2-1]=1;
    }
    for(int i=0;i<m;i++){
        cin>>op;
        if(op==1){
            cin>>ch;
            s+=ch;
        }else{
            cin>>ch1>>ch2;
            s+=ch1;
            s+=ch2;
        }
    }
    cin>>k;

    for(int i=0;i<s.size();i++){
        if(s[i]=='R' or s[i]=='L'){
            rotate90(s[i]);
        }else if(s[i]=='Q'){
            rotate180();
        }else if(s[i]=='H' or s[i]=='V'){
            rotateHV(s[i]);
        }else {
            a[s[i]-'0'-1][s[i+1]-'0'-1]=a[s[i]-'0'-1][s[i+1]-'0'-1]==0?1:0;
            i++;
        }
    }

    for(int i=0;i<n;i++){
        for(int j=0;j<n;j++){
            if(k<=0)break;
            if(a[i][j]==1){
                    cout<<i+1<<" "<<j+1<<endl;
                k--;
            }
        }
    }
}
