#include <algorithm>
#include <cstdio>
#include <iostream>
#define N 300000
using namespace std;
int n,br=0,rot=0,flp=0;
struct Point
{
    int x,y,olx,oly;
    Point(){}
    Point(int x,int y):x(x),y(y){}
    bool operator==(Point b)
    {
        if(x==b.x && y==b.y) return 1;
        return 0;
    }
}p[N];

Point conv12(Point a)
{
    Point b;
    b.olx = a.x; b.oly = a.y;
    if(n%2)
    {
        b.x = a.y - (n+1)/2;
        b.y = (n+1)/2 - a.x;
    }
    else
    {
        if(a.y<=n/2) b.x=a.y - n/2 - 1;
        else b.x=a.y - n/2;
        if(a.x<=n/2) b.y=n/2 - a.x + 1;
        else b.y=n/2-a.x;
    }
    return b;
}

Point conv21(Point b)
{
    Point a;
    if(n%2)
    {
        a.y = b.x + (n+1)/2;
        a.x = (n+1)/2 - b.y;
    }
    else
    {
        if(b.x<0) a.y = b.x + n/2 + 1;
        else a.y= b.x + n/2;
        if(b.y>0) a.x = n/2 - b.y + 1;
        else a.x=n/2-b.y;
    }
    return a;
}

void rot90(Point &a)
{
    Point b=a;
    b.x=-a.y;
    b.y=a.x;
    a=b;
}

void flip(Point &a)
{
    Point b=a;
    b.y=-a.y;
    a=b;
}

bool f(Point a,Point b)
{
    if(a.y==b.y) return a.x<b.x;
    return a.y>b.y;
}

void solve()
{
    int t,q;
    cin>>n>>t>>q;
 //   if(n%2==1) for(;;);
    int i,x,y,k;
    for(i=1; i<=t; i++)
    {
        scanf("%i %i",&x,&y);
        Point a(x,y);
        p[br++]=conv12(a);
    }
    for(i=1; i<=q; i++)
    {
        int t;
        char op;
        scanf(" %i",&t);
        if(t==1)
        {
            scanf(" %c",&op);
            switch(op)
            {
                case'R': rot=flp%2?rot+3:rot+1; break;
                case'L': rot=flp%2?rot+1:rot+3; break;
                case'Q': rot+=2; break;
                case'V': flp++; break;
                case'H': flp++; rot+=2; break;
            }
        }
        else
        {
            scanf(" %i %i",&x,&y);
            Point a(x,y),b=conv12(a);
            rot%=4; flp%=2;
            if(flp) flip(b);
            for(int i=0; i<rot; i++) rot90(b);
            p[br++]=b;
        }
    }
    rot%=4; flp%=2;
    for(int i=0; i<br; i++)
    {
       // cout<<rot<< endl;
        for(int j=0; j<4-rot; j++) rot90(p[i]);
        if(flp) flip(p[i]);
       // cout<<p[i].x<<" "<<p[i].y<< endl;
    }
    sort(p,p+br,f);
    cin>>k;
    int pos=0,kk=0;
    while(kk<k)
    {
        int j=pos;
        Point a=conv21(p[pos]);
        while(j<br && p[j]==p[pos]) j++;
        if((j-pos)%2) kk++, cout<<a.x<<" "<<a.y<< endl;
        pos = j;
    }
}

int main()
{
    solve();
    return 0;
}
/*
3 3 6
1 1
3 2
3 3
1 R
1 H
2 2 1
1 V
2 1 3
1 H
2
*/
