#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

int n,t,q,k,cntl,cntr,v_parity,h_parity;
set < pair < int, int > > s;
vector < pair < int, int > > arr;

pair < int, int > perform_r(pair < int, int > a) {
	return make_pair(a.second,n-a.first+1);
}

pair < int, int > perform_l(pair < int, int > a) {
	return make_pair(n-a.second+1,a.first);
}

pair < int, int > perform_v(pair < int, int > a) {
	return make_pair(n-a.first+1,a.second);
}

pair < int, int > perform_h(pair < int, int > a) {
	return make_pair(a.first,n-a.second+1);
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	
	int i,x,y,type;
	char ch;
	
	cin>>n>>t>>q;
	
	for(i=1;i<=t;i++) {
		cin>>x>>y;
		s.insert(make_pair(x,y));
	}
	
	while(q--) {
		cin>>type;
		
		if(type==1) {
			cin>>ch;
			
			if(ch=='L') {
				++cntl;
			}
			else if(ch=='R') {
				++cntr;
			}
			else if(ch=='Q') {
				cntr+=2;
			}
			else if(ch=='V') {
				v_parity^=1;
				swap(cntl,cntr);
			}
			else if(ch=='H') {
				h_parity^=1;
				swap(cntl,cntr);
			}
		}
		else {
			cin>>x>>y;
			pair < int, int > curr=make_pair(x,y);
			
			//Find the original coordinates
			if(cntl>cntr) {
				for(i=1;i<=(cntl-cntr)%4;i++) {
					curr=perform_r(curr);
				}
			}
			else {
				for(i=1;i<=(cntr-cntl)%4;i++) {
					curr=perform_l(curr);
				}
			}
			if(v_parity) {
				curr=perform_v(curr);
			}
			if(h_parity) {
				curr=perform_h(curr);
			}
			
			if(s.find(curr)!=s.end()) {
				s.erase(curr);
			}
			else {
				s.insert(curr);
			}
		}
	}
	
	cin>>k;
	
	for(set < pair < int, int > >::iterator it=s.begin();it!=s.end();it++) {
		pair < int, int > curr=*it;
		
		//Find the current coordinates
		if(v_parity) {
			curr=perform_v(curr);
		}
		if(h_parity) {
			curr=perform_h(curr);
		}
		
		if(cntl>cntr) {
			for(i=1;i<=(cntl-cntr)%4;i++) {
				curr=perform_l(curr);
			}
		}
		else {
			for(i=1;i<=(cntr-cntl)%4;i++) {
				curr=perform_r(curr);
			}
		}
		
		arr.push_back(curr);
	}
	
	sort(arr.begin(),arr.end());
	for(i=0;i<k;i++) {
		cout<<arr[i].first<<' '<<arr[i].second<<endl;
	}
	
	return 0;
}

/*
3 3 6
1 1
3 2
3 3
1 R
1 H
2 2 1
1 V
2 1 3
1 H
2
*/
