#include <bits/stdc++.h>

using namespace std;

const int N = 300007;

struct point {
	int x,y,idx,type;
};

int n;
point a[N];
vector < pair < int, int > > ans;
point leftmost;
int leftmost_idx;
vector < int > waiting;
int last;

long long s(point a, point b, point c) {
	return ((a.x-b.x)*1ll*(a.y+b.y) + (b.x-c.x)*1ll*(b.y+c.y) + (c.x-a.x)*1ll*(c.y+a.y));
}

bool cmp(point a, point b) {
	return s(leftmost,a,b)>0;
}

void add_edge(int x, int y) {
	ans.push_back(make_pair(x,y));
}

int main() {
	int i,j;
	
	scanf("%d", &n);
	for(i=1;i<=n;i++) {
		scanf("%d %d", &a[i].x, &a[i].y);
		a[i].type=0;
		a[i].idx=i;
	}
	for(i=n+1;i<=n+n;i++) {
		scanf("%d %d", &a[i].x, &a[i].y);
		a[i].type=1;
		a[i].idx=i;
	}
	
	leftmost=a[1];
	leftmost_idx=1;
	
	for(i=2;i<=2*n;i++) {
		if(a[i].x<leftmost.x || (a[i].x==leftmost.x && a[i].y<leftmost.y)) {
			leftmost=a[i];
			leftmost_idx=i;
		}
	}
	
	swap(a[1],a[leftmost_idx]);
	
	sort(a+2,a+1+2*n,cmp);
	last=-1;
	
	for(i=2;i<=2*n;i++) {
		if(a[i].type!=a[1].type) {
			add_edge(a[i].idx,a[1].idx);
			last=a[i].idx;
			for(j=0;j<(int)(waiting.size());j++) {
				add_edge(a[i].idx,waiting[j]);
			}
			waiting.clear();
		}
		else {
			if(last==-1) {
				waiting.push_back(a[i].idx);
			}
			else {
				 add_edge(a[i].idx,last);
			}
		}
	}
	
	printf("%d\n", (int)(ans.size()));
	for(i=0;i<(int)(ans.size());i++) {
		printf("%d %d\n", ans[i].first, ans[i].second);
	}
	
	return 0;
}
/*
6
6 5
3 3
5 2
7 2
9 5
9 1

5 8
2 4
6 3
8 0
10 4
8 7
*/
