#include <cstdio>
#include <iostream>
#include <vector>
#include <utility>
#include <algorithm>

#define endl '\n'
#define prev abcd

using namespace std;

int n, cntBl, q, x, y, type, k, cntLeft=0, cntHV=0, qx, qy, smth;
string transf, prev="";

vector<pair<pair<int, int>, bool> > black;

bool cmp(pair<pair<int, int>, bool> ff, pair<pair<int, int>, bool> ss)
{
    if(ff.second==ss.second)
    {
        if(ff.first.first==ss.first.first) return ff.first.second<ss.first.second;
        return ff.first.first<ss.first.first;
    }
    return ff.second>ss.second;
}

int main ()
{
    //freopen("i1.txt", "r", stdin);
    ios::sync_with_stdio(false);cin.tie(NULL);
    cin>>n>>cntBl>>q;
    for(int i=0; i<cntBl; ++i)
    {
        cin>>x>>y;
        black.push_back({{x, y}, 1});
    }
    while(q--)
    {
        cin>>type;
        if(type==1)
        {
            cin>>transf;
            if(transf=="R") cntLeft+=3;
            else if(transf=="L") cntLeft++;
            else if(transf=="Q") cntLeft+=2;
        }
        else
        {
            cin>>x>>y;
            if(cntLeft)
            {
                cntLeft%=4;
                //cout<<"LEFT FOR "<<x<<" "<<y<<endl;
                //cout<<"cntLeft="<<cntLeft<<endl;
                qx=0;
                for(int i=0; i<(int)black.size(); ++i)
                {
                    if(!black[i].second) continue;
                    for(int j=0; j<cntLeft; ++j)
                    {
                        //cout<<"from "<<black[i].first.first<<", "<<black[i].first.second;
                        smth=black[i].first.first;
                        black[i].first.first=n-black[i].first.second+1;
                        black[i].first.second=smth;
                        //cout<<" to "<<black[i].first.first<<", "<<black[i].first.second<<endl;
                    }
                    if(black[i].first.first==x && black[i].first.second==y)
                    {
                        qx=1;
                        qy=i;
                    }
                }
                if(qx==1)
                {
                    //cout<<"it is black so we make it white\n";
                    black[qy].second=false;
                }
                else
                {
                    //cout<<"it is white so we make it black\n";
                    black.push_back({{x, y}, 1});
                }
                cntLeft=0;
            }
            else while(1){}
        }
    }
    if(cntLeft)
    {
        cntLeft%=4;
        //cout<<"LEFT FINAL\n";
        //cout<<"cntLeft="<<cntLeft<<endl;
        for(int i=0; i<(int)black.size(); ++i)
        {
            if(!black[i].second) continue;
            for(int j=0; j<cntLeft; ++j)
            {
                //cout<<"from "<<black[i].first.first<<", "<<black[i].first.second;
                smth=black[i].first.first;
                black[i].first.first=n-black[i].first.second+1;
                black[i].first.second=smth;
                //cout<<" to "<<black[i].first.first<<", "<<black[i].first.second<<endl;
            }
        }
    }
    cin>>k;
    sort(black.begin(), black.end(), cmp);
    for(int i=0; i<k; ++i)
    {
        cout<<black[i].first.first<<" "<<black[i].first.second<<endl;
    }
    return 0;
}
