#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
using namespace std;
int n, t, k, m;
vector<pair<int,int> > a;

struct {
    bool operator()(pair<int,int> a, pair<int,int> b)
    {
        if(a.first < b.first)return true;
        if(a.first > b.first)return false;

        if(a.second < b.second)return true;
        if(a.second > b.second)return false;
        return true;
    }
} sortVector;

struct Comp{
    bool operator()(const pair<int,int> &a, const pair<int,int> &b) const
    {
        if(a.first < b.first)return true;
        if(a.first > b.first)return false;

        if(a.second < b.second)return true;
        if(a.second > b.second)return false;

        return false;
    }

};

set< pair<int,int>, Comp > b;
pair<int,int> ignorePair;
void doOp(char op){
    b.clear();
    bool haveDeleted = false;


    switch(op){
        case 'R':
            for(int o = 0; o < t; o++){
                if(a[o] == ignorePair){a.erase(a.begin() + o,a.begin() + o + 1);t--;o--;continue;}
                pair<int,int> p = pair<int,int>(a[o].second,n-a[o].first+1);
                a[o] = p;
                b.insert(p);
            }
            break;
        case 'L':
            for(int o = 0; o < t; o++){
                pair<int,int> p = pair<int,int>(n-a[o].second+1,a[o].first);
                if(a[o] == ignorePair){a.erase(a.begin() + o,a.begin() + o + 1);t--;o--;continue;}
                a[o] = p;
                b.insert(p);
            }
            break;
        case 'Q':
            for(int o = 0; o < t; o++){
                if(a[o] == ignorePair){a.erase(a.begin() + o,a.begin() + o + 1);t--;o--;continue;}
                pair<int,int> p = pair<int,int>(n-a[o].first+1,n-a[o].second+1);
                a[o] = p;
                b.insert(p);
            }
            break;
        case 'V':
            for(int o = 0; o < t; o++){
                if(a[o] == ignorePair){a.erase(a.begin() + o,a.begin() + o + 1);t--;o--;continue;}
                pair<int,int> p = pair<int,int>(n-a[o].first+1,a[o].second);
                a[o] = p;
                b.insert(p);
            }
            break;
        case 'H':
            for(int o = 0; o < t; o++){
                if(a[o] == ignorePair){a.erase(a.begin() + o,a.begin() + o + 1);t--;o--;continue;}
                pair<int,int> p = pair<int,int>(a[o].first,n-a[o].second+1);
                a[o] = p;
                b.insert(p);
            }
            break;

    }

    ignorePair = pair<int,int>(0,0);

}

void switchColor(int tx, int ty){
    pair<int,int> p = pair<int,int>(tx,ty);
    auto search = b.find(p);
    if(search != b.end()) {
        //cout<<"GOTEM";
        ignorePair = p;
        //t--;
    }else{
        a.push_back(p);
        t++;
    }
}


int main()
{
    cin>>n>>t>>m;
    int tx,ty;
    for(int i = 0; i < t; i++){
        cin>>tx>>ty;
        a.push_back(pair<int,int>(tx,ty));
    }
    int type;
    char op;
    for(int i = 0; i < m; i++){
        cin>>type;
        if(type == 1){
            cin>>op;
            doOp(op);

        }else{
            cin>>tx>>ty;
            switchColor(tx,ty);
        }

        /*for(int i = 0; i < t; i++){
            cout<< a[i].first << " " << a[i].second << endl;
        }*/
    }

    sort(a.begin(), a.end(), sortVector);

    cin>>k;

    for(int i = 0; i < k; i++){
        cout<< a[i].first << " " << a[i].second << endl;
    }
    return 0;
}
