#include <iostream>
#include <algorithm>
#include <chrono>
#include <ctime>
using namespace std;
using namespace std::chrono;
int a[1000005],b[1000005];
int n;
int main(){
    time_point<system_clock> start,end;

    cin>>n;
    for(int i = 1; i <= n; i++){
        cin>>a[i];
        b[i] = i;
    }

    start = system_clock::now();


    //bool solved = false;
    int cnt = 0;

    std::chrono::duration<double> dur;
    do{
        bool isCorrect = true;
        for(int i = 1; i <= n; i++){
            if(a[b[i]] != b[a[i]]){
                isCorrect = false;
                break;
            }
        }

        if(isCorrect){
            /*for(int i = 1; i <= n; i++){
                cout<<b[i]<<"  ";
            }
            cout<<endl;*/
            cnt++;
            cnt%=1000007;
        }
        end = system_clock::now();
        dur = (end - start);
        //cout<<dur.count()<<endl;
    }while(next_permutation(b+1,b+n+1) && dur.count() < 0.35);

    cout<<cnt<<endl;
}
