#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int32_t MAX_N = 10005;

bool isVisited[MAX_N], can[MAX_N][MAX_N], used[MAX_N];
int32_t n, a[MAX_N], b[MAX_N], cnt[MAX_N], cycleInd, ans;
vector< int32_t > cycle[MAX_N], needed[MAX_N][MAX_N];

void BruteForce(int32_t ind) {
    if(ind > cycleInd) {
        ans++;
        return;
    }

    for(int32_t i = 1; i <= n; i++) {
        if(can[ind][i]) {
            bool isOk = true;
            for(int32_t x : needed[ind][i]) {
                if(used[x]) {
                    isOk = false;
                    break;
                }
            }

            if(isOk) {
                for(int32_t x : needed[ind][i]) {
                    used[x] = true;
                }
                BruteForce(ind + 1);
                for(int32_t x : needed[ind][i]) {
                    used[x] = false;
                }
            }
        }
    }
}

int main() {
    cin >> n;

    for(int32_t i = 1; i <= n; i++) {
        cin >> a[i];
    }

    cycleInd = 1;
    for(int32_t i = 1; i <= n; i++) {
        if(!isVisited[i]) {
            int32_t curr = i;
            while(!isVisited[curr]) {
                cycle[cycleInd].push_back(curr);
                isVisited[curr] = true;
                curr = a[curr];
            }
            cycleInd++;
        }
    }

    cycleInd--;
    for(int32_t i = 1; i <= cycleInd; i++) {
        for(int32_t j = 1; j <= n; j++) {
            b[cycle[i][cycle[i].size() - 1]] = j;
            for(int32_t p = cycle[i].size() - 2; p >= 0; p--) {
                b[cycle[i][p]] = a[b[cycle[i][p + 1]]];
            }

            bool isOk = true;
            memset(cnt, 0, sizeof(cnt));
            for(int32_t x : cycle[i]) {
                if(cnt[b[x]] != 0) {
                    isOk = false;
                    break;
                }

                cnt[b[x]]++;
            }

            if(isOk) {
                can[i][j] = true;
                for(int32_t x : cycle[i]) {
                    needed[i][j].push_back(b[x]);
                }
            }
        }
    }

    memset(used, 0, sizeof(used));
    BruteForce(1);

    cout << ans << endl;
    return 0;
}

