#include<iostream>
#include<stack>
#include<set>
using namespace std;
struct oper{
	int t;
	char c;
	int r,s;
};
const int MAXN=100005;
pair<int,int> init[MAXN];
int n,swapped,rowChange,colChange;
void normalize(int &r,int &c){
	if(swapped){
		swap(r,c);
	}
	if(rowChange){
		r=(n-1)-r;
	}
	if(colChange){
		c=(n-1)-c;
	}
}
int main(){
	cin.tie(NULL);
	ios::sync_with_stdio(false);
	int t,m;
	cin>>n>>t>>m;
	for(int i=0;i<t;i++){
		cin>>init[i].first>>init[i].second;
	}
	stack<oper> s;
	oper curr;
	for(int i=0;i<m;i++){
		cin>>curr.t;
		if(curr.t==1){
			cin>>curr.c;
		}else{
			cin>>curr.r>>curr.s;
		}
		s.push(curr);
	}
	set<pair<int,int>> blacks;
	while(!s.empty()){
		curr=s.top();
		s.pop();
		/*for(int i=0;i<n;i++){
			for(int j=0;j<n;j++){
				int p=i,q=j;
				normalize(p,q);
				cout<<i<<" "<<j<<" "<<p<<" "<<q<<"\n";
			}
		}
		cout<<"\n";*/
		if(curr.t==1){
			if(curr.c=='R'){
				swapped^=1;
				swap(rowChange,colChange);
				rowChange^=1;
			}
			if(curr.c=='L'){
				swapped^=1;
				swap(rowChange,colChange);
				colChange^=1;
			}
			if(curr.c=='Q'){
				rowChange^=1;
				colChange^=1;
			}
			if(curr.c=='H'){
				colChange^=1;
			}
			if(curr.c=='V'){
				rowChange^=1;
			}
		}else{
			curr.r--;
			curr.s--;
			//cout<<"Old: "<<curr.r<<" "<<curr.s<<"\n";
			normalize(curr.r,curr.s);
			//cout<<"New: "<<curr.r<<" "<<curr.s<<"\n";
			if(blacks.find({curr.r,curr.s})==blacks.end()){
				blacks.insert({curr.r,curr.s});
			}else{
				blacks.erase({curr.r,curr.s});
			}
		}
	}
	for(int i=0;i<t;i++){
		init[i].first--;
		init[i].second--;
		//cout<<"Old: "<<init[i].first<<" "<<init[i].second<<"\n";
		normalize(init[i].first,init[i].second);
		//cout<<"New: "<<init[i].first<<" "<<init[i].second<<"\n";
		if(blacks.find(init[i])==blacks.end()){
			blacks.insert(init[i]);
		}else{
			blacks.erase(init[i]);
		}
	}
	int k;
	cin>>k;
	auto it=blacks.begin();
	for(int i=0;i<k;i++){
		cout<<(*it).first+1<<" "<<(*it).second+1<<"\n";
		it++;
	}
	return 0;
}
