#include<iostream>
#include<cmath>
#include<algorithm>
using namespace std;
const int MAXN=150005;
struct point{
    long long x,y;
    int orig;
}plant[MAXN],protein[MAXN];
/*long long dist(point a,point b){
    return (a.x-b.x)*(a.x-b.x)+(a.y-b.y)*(a.y-b.y);
}*/
long long orient(point a,point b,point c){
    b.x-=a.x;
    c.x-=a.x;
    b.y-=a.y;
    c.y-=a.y;
    return b.x*c.y-b.y*c.x;
}
/*double angle(point a,point b,point c){
    long long calc=dist(b,a)+dist(c,a)-dist(b,c);
    double calcF=calc/(2.0*sqrt(dist(b,a)*dist(c,a)));
    double res=acos(calcF);
    if(orient(b,a,c)<0){
        return 2*M_PI-res;
    }
    return res;
}*/
point selectPr,selectPl;
bool cmp(point a,point b){
    /*bool val1=orient(selectPl,selectPr,a)>0;
    bool val2=orient(selectPl,selectPr,b)>0;
    if(!(val1^val2)){*/
        return orient(a,selectPr,b)>0;
    /*}
    return val1;*/
}
int main(){
    cin.tie(NULL);
    ios::sync_with_stdio(false);
    int n;
    cin>>n;
    for(int i=0;i<n;i++){
        cin>>protein[i].x>>protein[i].y;
        protein[i].orig=i+1;
    }
    selectPl.y=-300005;
    int ind=-1;
    for(int i=0;i<n;i++){
        cin>>plant[i].x>>plant[i].y;
        plant[i].orig=i+1+n;
        if(plant[i].y>selectPl.y){
            selectPl=plant[i];
            ind=i;
        }
    }
    swap(plant[ind],plant[0]);
    selectPr=protein[0];
    sort(plant+1,plant+n,cmp);
    sort(protein+1,protein+n,cmp);
    /*cout<<"Proteins: ";
    for(int i=0;i<n;i++){
       cout<<protein[i].orig<<"\n";
    }
    cout<<"Plants: ";
    for(int i=0;i<n;i++){
     cout<<plant[i].orig<<"\n";
    }*/
    cout<<2*n-1<<"\n";
    for(int i=0;i<n;i++){
        cout<<"1 "<<n+i+1<<"\n";
    }
    int cnt=1;
    for(int i=0;i<n;i++){
        while(cnt<n&&(i==n-1||cmp(protein[cnt],plant[(i+1)%n]))){
            cout<<plant[i].orig<<" "<<protein[cnt].orig<<"\n";
            cnt++;
        }
    }
    return 0;
}
