#include<iostream>
using namespace std;
const int MAXN=1000005,MOD=1e9+7;
int a[MAXN],sz;
bool used[MAXN];
void dfs(int pos){
    used[pos]=true;
    sz++;
    if(!used[a[pos-1]]){
        dfs(a[pos-1]);
    }
}
long long cnt[MAXN];
long long fact[MAXN];
long long pow(long long val,int power){
    if(power<1) return 1;
    if(power==1) return val;
    long long res=pow(val,power/2);
    res*=res;
    res%=MOD;
    if(power%2){
        res*=val;
        res%=MOD;
    }
    return res;
}
int main(){
    cin.tie(NULL);
    ios::sync_with_stdio(false);
    int n;
    cin>>n;
    fact[0]=1;
    for(int i=0;i<n;i++){
        cin>>a[i];
        fact[i+1]=(i+1)*fact[i];
        fact[i+1]%=MOD;
    }
    long long ans=1;
    for(int i=0;i<n;i++){
        if(!used[a[i]]){
            sz=0;
            dfs(a[i]);
            cnt[sz]++;
            //ans*=sz;
            //ans%=MOD;
        }
    }
    for(int i=1;i<=n;i++){
        if(cnt[i]!=0){
            ans*=pow(i,cnt[i]);
            ans%=MOD;
            ans*=fact[cnt[i]];
            ans%=MOD;
        }
    }
    cout<<ans<<"\n";
    return 0;
}
