#include <iostream>
#include <algorithm>
#include <cmath>
#include <cstdlib>
using namespace std;

struct p {
    int x, y, ind;
    bool col;
    p () {}
}input[(1<<20)];
int n;
long long cross( p a, p b, p c ) {
    a.x -= b.x;
    c.x -= b.x;
    a.y -= b.y;
    c.y -= b.y;
    return 1LL*a.x*c.y - 1LL*a.y*c.x;
}

bool cmp ( p a, p b ) {
    return cross( a, input[0], b ) > 0;

}

void getHull ( ) {
    int minInd = 0;
    for ( int i = 0 ; i < n ; i ++ ) {
        if ( input[i].y < input[minInd].y || (input[i].y == input[minInd].y && input[i].x < input[minInd].x ) ) {
            minInd = i;
        }
    }
    swap( input[0], input[minInd] );

    sort( input+1, input + n, cmp );

    /*
    cout << "\n";
    for ( int i = 0 ; i < n ; i ++ ) {
        cout << input[i].x << " " << input[i].y << " " << input[i].ind << "\n";
    }
    cout << "\n";
    */
    int fInd = 0;
    for ( int i = 1 ; i < n ; i ++ ) {
        if ( input[i].col != input[0].col ) { fInd = i; break; }
    }

    for ( int i = 1 ; i < n ; i ++ ) {
        if ( input[i].col != input[0].col ) {
            fInd = i;
            cout << input[0].ind << " " << input[i].ind << "\n";
        }else {
            cout << input[fInd].ind << " " << input[i].ind << "\n";
        }
    }

}

int main () {
    cin >> n;
    for ( int i = 0 ; i < n ; i ++ ) {
        cin >> input[i].x >> input[i].y;
        input[i].col = 0;
        input[i].ind = i+1;
    }
    for ( int i = 0 ; i < n ; i ++ ) {
        cin >> input[n+i].x >> input[n+i].y;
        input[n+i].col = 1;
        input[n+i].ind = i+n+1;
    }
    n *= 2;
    cout << n-1 << "\n";
    getHull();

    return 0;
}
/*
2
0 0
0 1
1 1
1 0
*/
