#include <bits/stdc++.h>
#define endl '\n'

#pragma GCC optimize ("O3")
#pragma GCC target ("sse4")

using namespace std;
template<class T, class T1> void chkmin(T &x, const T1 &y) { if(x > y) x = y; }
template<class T, class T1> void chkmax(T &x, const T1 &y) { if(x < y) x = y; }
const int MAXN = (1 << 20);

int n;
int a[MAXN];

void read()
{
	cin >> n;
	for(int i = 1; i <= n; i++)
        cin >> a[i];
}

vector<int> adj[MAXN];

void solve()
{
    vector<int> perm(n + 1);
    for(int i = 1; i <= n; i++)
        perm[i] = i;

    int answer = 0;
    do
    {
        bool ok = 1;
        for(int i = 1; i <= n; i++)
            if(a[perm[i]] != perm[a[i]])
                ok = 0;

        if(ok)
        {
            answer++;


        }

    }
    while(next_permutation(perm.begin() + 1, perm.end()));

    cout << answer << endl;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);

	read();
	solve();
	return 0;
}

/**

3 3 6
1 1
3 2
3 3
1 R
1 H
2 2 1
1 V
2 1 3
1 H
2

*/
