#include <bits/stdc++.h>
#define endl '\n'

#pragma GCC optimize ("O3")
#pragma GCC target ("sse4")

using namespace std;
template<class T, class T1> void chkmin(T &x, const T1 &y) { if(x > y) x = y; }
template<class T, class T1> void chkmax(T &x, const T1 &y) { if(x < y) x = y; }
const int MAXN = (1 << 20);
const int mod = (int)1e9 + 7;

int n;
int a[MAXN];

void read()
{
	cin >> n;
	for(int i = 1; i <= n; i++)
        cin >> a[i];
}

int fact[MAXN];
bool used[MAXN];
int cnt[MAXN];

void solve()
{
    int64_t answer = 1;
    for(int i = 1; i <= n; i++)
        if(!used[i])
        {
            int c = 0, v = i;
            while(!used[v])
            {
                c++;
                used[v] = 1;
                v = a[v];
            }

            answer = (answer * 1ll * c) % mod;
            cnt[c]++;
        }

    fact[0] = 1;
    for(int i = 1; i <= n; i++)
        fact[i] = (fact[i - 1] * 1ll * i) % mod;

    for(int i = 1; i <= n; i++)
        answer = (answer * 1ll * fact[cnt[i]]) % mod;

    /*
    vector<int> perm(n + 1);
    for(int i = 1; i <= n; i++)
        perm[i] = i;



    do
    {
        bool ok = 1;
        for(int i = 1; i <= n; i++)
            if(a[perm[i]] != perm[a[i]])
                ok = 0;

        if(ok)
        {
            answer++;
            for(int i = 1; i <= n; i++)
                cout << perm[i] << " ";
            cout << endl;
        }

    }
    while(next_permutation(perm.begin() + 1, perm.end()));
    */

    cout << answer << endl;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);

	read();
	solve();
	return 0;
}

/**

5
3 1 2 5 4

*/
