#include <bits/stdc++.h>
#define endl '\n'

#pragma GCC optimize ("O3")
#pragma GCC target ("sse4")

using namespace std;
template<class T, class T1> void chkmin(T &x, const T1 &y) { if(x > y) x = y; }
template<class T, class T1> void chkmax(T &x, const T1 &y) { if(x < y) x = y; }
const int MAXN = (1 << 20);
const long double PI = acos(-1);

struct point
{
    int x, y, idx;
    point() { x = y = idx = -1; }
    point(int _x, int _y, int _idx) { x = _x; y = _y; idx = _idx; }
};

int n;
point p[MAXN], q[MAXN];

void read()
{
    cin >> n;
    for(int i = 0; i < n; i++) { cin >> p[i].x >> p[i].y; p[i].idx = i + 1; }
    for(int i = 0; i < n; i++) { cin >> q[i].x >> q[i].y; q[i].idx = i + 1 + n; }
}

long double get_angle(point pp)
{
    long double d = atan2(pp.y - p[0].y, pp.x - p[0].x);
    return d;
}

bool by_angle(point x, point y) { return get_angle(x) < get_angle(y); }

bool used[MAXN];



void solve()
{
    for(int i = 0; i < n; i++)
        if(p[0].y > p[i].y)
            swap(p[0], p[i]);

    for(int i = 0; i < n; i++)
        if(p[0].y > q[i].y)
        {
            for(int j = 0; j < n; j++) swap(p[j], q[j]);
            break;
        }

    for(int i = 0; i < n; i++)
        if(p[0].y > p[i].y)
            swap(p[0], p[i]);

            cout << 2 * n - 1 << endl;

    vector<point> li;
    for(int i = 1; i < n; i++) li.push_back(p[i]);
    for(int i = 0; i < n; i++)
    {
        cout << p[0].idx << " " << q[i].idx << endl;
        used[q[i].idx] = 1;
        li.push_back(q[i]);
    }

    sort(li.begin(), li.end(), by_angle);
    vector<int> for_beg;

    int last = -1;
    for(auto it: li)
    {
        if(used[it.idx] == 0)
        {
            if(last == -1) for_beg.push_back(it.idx);
            else { cout << last << " " << it.idx << endl; }
        }
        else
        {
            if(last == -1)
            {
                for(int x: for_beg) cout << it.idx << " " << x << endl;
                last = it.idx;
            }
        }
    }
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);

	read();
	solve();
	return 0;
}

/**

6
6 5
3 3
5 2
7 2
9 5
9 1
5 8
2 4
6 3
8 0
10 5
8 7

*/

