# include <cstdio>
# include <set>
# include <vector>
# include <algorithm>

using namespace std;

const int MAX_N = 1e5 + 10;
const int MAX_M = 1e5 + 10;

int n, m, t, k;

set <pair <int, int>> s;
vector <pair <int, int>> rs;

inline pair <int, int> rot (pair <int, int> x, char c)
{
	if (c == 'R')
		return {x.second, n - x.first + 1};
	if (c == 'L')
		return {n - x.second + 1, x.first};
	if (c == 'Q')
		return {n - x.first + 1, n - x.second + 1};
	if (c == 'V')
		return {n - x.first + 1, x.second};
	if (c == 'H')
		return {x.first, n - x.second + 1};
	printf ("ahh\n");
	return {-1, -1};
}

int main ()
{
	int i, j, type;
	char tt;
	pair <int, int> c;

	scanf ("%d%d%d", &n, &m, &t);

	for (i = 1; i <= m; i ++)
	{
		scanf ("%d%d", &c.first, &c.second);
		s.insert (c);
	}

	for (i = 0; i < t; i ++)
	{
		scanf ("%d", &type);
		if (type == 1)
		{
			scanf (" %c", &tt);
			rs.clear ();
			for (set <pair <int, int>> :: iterator it = s.begin (); it != s.end (); it ++)
			{
				c = *it;
				rs.push_back (rot (c, tt));
			}
			s.clear ();
			for (j = 0; j < (int) rs.size (); j ++)
				s.insert (rs[j]);
		}
		else
		{
			scanf ("%d%d", &c.first, &c.second);

			if (s.find (c) != s.end ())
				s.erase (c);
			else
				s.insert (c);
		}
	}

	scanf ("%d", &k);

	for (set <pair <int, int>> :: iterator it = s.begin (); it != s.end () && k; it ++, k --)
		printf ("%d %d\n", it->first, it->second);

	return 0;
}

