# include <cstdio>
# include <algorithm>

using namespace std;

const int MAX_N = 1e6 + 10;

const long long MOD = 1000000007;

int n;

int p[MAX_N];
int u[MAX_N];
int c[MAX_N];
int q[MAX_N];

int ans = 0;

int f;

bool loop (int x, int a)
{
    if (u[a])
        return (q[x] == a);

    ///printf ("add %d %d\n", x, a);

    q[x] = a;
    u[a] = true;

    if (loop (p[x], p[q[x]]))
        return true;

    q[x] = -1;
    u[a] = false;

    return false;
}

int st, cnt;

void null_loop (int x, int a)
{
    if (x == st)
    {
        if (cnt)
            return;
        cnt ++;
    }

    q[x] = -1;
    u[a] = false;

    null_loop (p[x], p[a]);
}

void go (int x)
{
    ///printf ("%d\n", x);
    /**
    if (clock () > 0.39 * CLOCKS_PER_SEC)
    {
        printf ("%d\n", ans);
        exit (0);
    }
    **/

    if (x == n + 1)
    {
        ///for (int i = 1; i <= n; i ++)
        ///    printf ("%d ", q[i]);
        ///printf ("\n");
        ans ++;
        return;
    }

    if (q[x] != -1)
    {
        go (x + 1);
        return;
    }

    int i;
    for (i = 1; i <= n; i ++)
    {
        if (loop (x, i))
        {
            ///printf ("yoyo %d %d\n", x, i);
            go (x + 1);
            st = x;
            cnt = 0;
            null_loop (x, i);
        }
    }
}

void dfs (int x)
{
    while (1)
    {
        cnt ++;
        u[x] = true;
        if (!u[p[x]])
            x = p[x];
        else
            break;
    }
}

int main ()
{
    int i;
    scanf ("%d", &n);
    for (i = 1; i <= n; i ++)
    {
        scanf ("%d", &p[i]);
        q[i] = i;
    }

    for (i = 1; i <= n; i ++)
    {
        u[i] = 0;
        q[i] = -1;
    }
    /**
    if (n < 100)
    {
        go (1);
        printf ("%lld\n", ans);
        return 0;
    }
    **/

    for (i = 1; i <= n; i ++)
    {
        cnt = 0;
        if (!u[i])
            dfs (i);
        c[cnt] ++;
    }

    ans = 1;

    for (i = 1; i <= n; i ++)
    {
        if (!c[i])
            continue;
        ans = (ans * i) % MOD;
        while (c[i])
        {
            ans = (ans * c[i]) % MOD;
            c[i] --;
        }
    }

    printf ("%lld\n", ans);

    return 0;
}
