#include <bits/stdc++.h>
#define MAX_Number 1000005
using namespace std;
void print();
void print2();
int n, m, t, opposite[6]={-1, 2, 1, -1, -1, -1};
vector< pair<int, int> > black;
deque<int> st;
bool cmp(pair<int,int> x, pair<int, int> y)
{
    if(x.first<y.first)
        return 1;
    if(x.first>y.first)
        return 0;
    if(x.second<y.second)
        return 1;
    return 0;
}
void read()
{
    scanf("%d %d %d", &n, &t, &m);
    int x, y;
    for(int i=1; i<=t; i++)
    {
        scanf("%d %d", &x, &y);
        black.push_back(make_pair(x, y));
    }
    sort(black.begin(), black.end(), cmp);
}
int toInt(char curr)
{
    if(curr=='L')
        return 1;
    if(curr=='R')
        return 2;
    if(curr=='Q')
        return 3;
    if(curr=='V')
        return 4;
    return 5;
}
void execute(int currtop)
{
    if(currtop==3)
    {
        if(st.empty())
        {
            st.push_back(2);
            st.push_back(2);
            return;
        }
        int newtop=st.back();
        if(newtop==4||newtop==5)
        {
            st.push_back(2);
            st.push_back(2);
            return;
        }
        if(st.size()==1)
        {
            st.pop_back();
            st.push_back(opposite[newtop]);
            return;
        }
        st.pop_back();
        if(st.back()==newtop)
            st.pop_back();
        else
            st.push_back(newtop);
    }
    if(st.empty())
    {
        st.push_back(currtop);
        return;
    }
    if(currtop==4||currtop==5)
        st.push_back(currtop);
    else
    if(st.back()==opposite[currtop])
        st.pop_back();
    else
        st.push_back(currtop);
}
void rotL()
{
    int sz=black.size(), prev;
    for(int i=0; i<sz; i++)
    {
        prev=black[i].first;
        black[i].first=n-black[i].second+1;
        black[i].second=prev;
    }
}
void rotR()
{
    int sz=black.size(), prev;
    for(int i=0; i<sz; i++)
    {
        prev=black[i].first;
        black[i].first=black[i].second;
        black[i].second=n-prev+1;
    }
}
void rotV()
{
    int sz=black.size();
    for(int i=0; i<sz; i++)
        black[i].first=n-black[i].first+1;
}
void rotH()
{
    int sz=black.size();
    for(int i=0; i<sz; i++)
        black[i].second=n-black[i].second+1;
}
void Rotate(int oper)
{
    if(oper==1)
        rotL();
    if(oper==2)
        rotR();
    if(oper==4)
        rotV();
    if(oper==5)
        rotH();
    sort(black.begin(), black.end(), cmp);
}
void flip(int x, int y)
{
    if(x==-1)
        return;
    int left=0, right=black.size()-1, middle;
    pair<int, int> toFind=make_pair(x, y);
    while(left<=right)
    {
        middle=left+(right-left)/2;
        if(black[middle]==toFind)
        {
            black.erase(black.begin()+(middle), black.begin()+middle+1);
            return;
        }
        if(cmp(toFind, black[middle]))
            right=middle-1;
        else
            left=middle+1;
    }
    black.insert(black.begin()+right+1, toFind);
}
void execute2(int x, int y)
{
    while(!st.empty())
    {
        Rotate(st.front());
        st.pop_front();
    }
    flip(x, y);
}
void queries()
{
    int type, x, y;
    char oper;
    while(m--)
    {
        scanf("%d", &type);
        if(type==1)
        {
            cin.get(oper);
            cin.get(oper);
            //cout<<oper<<endl;
            execute(toInt(oper));
        }
        else
        {
            scanf("%d %d", &x, &y);
            //cin.get(oper);
            execute2(x, y);
        }
    }
    execute2(-1, -1);
    int k;
    scanf("%d", &k);
    for(int i=0; i<k; i++)
        printf("%d %d\n", black[i].first, black[i].second);
}
int main()
{
    //freopen("input.txt", "r", stdin);
    read();
    queries();
    //print2();
    return 0;
}
void print2()
{
    for(int i=0; i<black.size(); i++)
        printf("%d %d\n", black[i].first, black[i].second);
}
void print()
{
    while(!st.empty())
    {
        printf("%d ", st.front());
        st.pop_front();
    }
}
