#include<iostream>
#include<vector>
#include<queue>
#include<set>
using namespace std;
int n, m, t, lvl = 0;
struct rect{
	int x;
	int y;
	bool used;
};
bool operator<(rect a, rect b){
	if(a.x!=b.x){
		if(a.x>b.x)return 1;
		else return 0;
	}
	else {
		if(a.y>b.y)return 1;
		else return 0;
	}
}
vector <rect> all;
priority_queue <rect> qu;
void rotateR(int &x, int &y){
	int x1 = y;
	int y1 = n - (x+y-1) + y;
	x = x1;
	y = y1;
}
void rotateL(int &x, int &y){
	int x1 = n - (x+y-1) + x;
	int y1 = x;
	x = x1;
	y = y1;
}
void rotate180(int &x, int &y){
	rotateR(x,y);
	rotateR(x,y);
}
void vertical(int &x, int &y){
	int x1 = n - (x+y-1) + y;
	int y1 = y;
	x = x1;
	y = y1;
}
void horizontal(int &x, int &y){
	int x1 = x;
	int y1 = n - (x+y-1) + x;
	x = x1;
	y = y1;
}
void rotate(char ch){
	if(ch=='R'){
		for(int i=0;i<all.size();i++){
			if(!all[i].used)rotateR(all[i].x,all[i].y);
		}
	}
	else if(ch == 'L'){
		for(int i=0;i<all.size();i++){
			if(!all[i].used)rotateL(all[i].x,all[i].y);
		}
	}
	else if(ch == 'Q'){
		for(int i=0;i<all.size();i++){
			if(!all[i].used)rotate180(all[i].x,all[i].y);
		}
	}
	else if(ch == 'H'){
		for(int i=0;i<all.size();i++){
			if(!all[i].used)horizontal(all[i].x,all[i].y);
		}
	}
	else {
		for(int i=0;i<all.size();i++){
			if(!all[i].used)vertical(all[i].x,all[i].y);
		}
	}
}
void print(){
	cout<<"----------------------"<<endl;
	for(int i=0;i<all.size();i++){
		cout<<all[i].x<<" "<<all[i].y<<" "<<all[i].used<<endl;
	}
}
main(){
	cin>>n>>t>>m;
	for(int i=0;i<t;i++){
		int x, y;
		cin>>x>>y;
		rect next;
		next.x = x;
		next.y = y;
		next.used = 0;
		all.push_back(next);
	}
	
	for(int i=0;i<m;i++){
		int action;
		cin>>action;
		if(action == 1){
			char ch;
			cin>>ch;
			rotate(ch);
		}
		else {
			int x, y;
			cin>>x>>y;
			rect a;
			a.x = x;
			a.y = y;
			a.used = 0;
			bool f = 0;
			for(int i=0;i<all.size();i++){
				if(all[i].x == x && all[i].y == y){
					all[i].used = (all[i].used ^ 1);
					f = 1;
				}
			}
			if(!f)all.push_back(a);
		}
	}
	for(int i = 0;i<all.size();i++){
		qu.push(all[i]);
	}
	int k;
	cin>>k;
	int i = 0;
	while(!qu.empty()&&i<k){
		rect a;
		a = qu.top();
		qu.pop();
		if(!a.used){
			cout<<a.x<<" "<<a.y<<endl;
			i++;
		}
	}
}
/*
3 3 6
1 1
3 2
3 3
1 R
1 H
2 2 1
1 V
2 1 3
1 H
2
*/
