#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cmath>
#define N 300003
using namespace std;
typedef long long ll;
int n,abr;
pair<int,int> ans[N];
struct Point
{
    ll x,y,i,tp;
}ps,p[N];

int mass[N],br,root,stop;
bool f[N];

double rast(int i,int j)
{
    return sqrt(  (p[i].x-p[j].x)*(p[i].x-p[j].x) + (p[i].y-p[j].y)*(p[i].y-p[j].y) );
}

bool f2(int i,int j)
{
    return (p[i].x-p[root].x)*rast(j,root) <
           (p[j].x-p[root].x)*rast(i,root);
}

void solve2()
{
    sort(mass,mass+br,f2);
    for(int i=0; i<br; i++)
    {
        if(stop==mass[i]) break;
        if(f[mass[i]]==0) ans[abr++]=make_pair(p[mass[i]].i,p[root].i);
            f[mass[i]]=1;
    }
}

void solve()
{
    int j,mni,li,ri;
    for(int i=1; i<=2*n; i++)
    {
        br=0; mni=i-1; stop=-1;
        li=ri=i;
        while(!p[i].tp)
        {
            li=p[i].x<p[li].x?i:li;
            ri=p[i].x>p[ri].x?i:ri;
            mass[br++]=i;
            i++;
            if(i>2*n)
            {
                root=mni;
                solve2();
                return;
            }
        }
        if(mni!=0) ans[abr++]=make_pair(p[mni+1].i,p[mni].i);
        root=i;
        solve2();
        br=0;
        while(i<=2*n && p[i].tp)
           mass[br++]=i, i++;
        stop=root; f[root]=1; root = li; solve2();
        stop=-1; root = ri; solve2();
        i--;
    }
}

void output()
{
    cout<<abr<< endl;
    for(int i=0; i<abr; i++)
    {
        cout<<ans[i].first<<" "<<ans[i].second<< endl;
    }
}

bool f1(Point a,Point b)
{
    if(a.y==b.y) return a.x<b.x;
    return a.y>b.y;
}

void input()
{
    cin>>n;
    for(int i=1; i<=2*n; i++)
    {
        p[i].i=i;
        p[i].tp= i<=n;
        scanf("%lli %lli",&p[i].x,&p[i].y);
    }
    sort(p+1,p+2*n+1,f1);
}

int main()
{
    input();
    solve();
    output();
    return 0;
}
/*
6
6 5
3 3
5 2
7 2
9 5
9 1
5 8
2 4
6 3
8 0
10 4
8 7
*/
