#include<iostream>
#include<vector>
#include<stack>
#include<queue>
#include<unordered_map>
#include<algorithm>
#include<math.h>
using namespace std;

const int MAX_N=150100;
int n;
struct Point
{
    long long x,y;
};
struct Angle
{
    int q;
    long double a;
    bool inf;
    int t;
};
Angle a[MAX_N*2];
Point p[MAX_N*2];

bool operator<(const Angle& a, const Angle& b)
{
    if (a.q!=b.q) return a.q<b.q;
    if (a.inf==0 && b.inf==0) return a.a>b.a;
    if (a.q==1)
    {
        if (a.inf==1) return 1;
        else return 0;
    }
    else if (a.q==2)
    {
        if (b.inf==1) return 1;
        else return 0;
    }
}

void input()
{
    cin>>n;
    for (int i=0;i<2*n;++i)
    {
        cin>>p[i].x>>p[i].y;
    }
}
void solve()
{
    cout<<2*n-1<<'\n';
    for (int i=n+1;i<=n*2;++i)
    {
        cout<<1<<' '<<i<<'\n';
    }
    long long dx,dy;
    for (int i=1;i<n*2;++i)
    {
        dy=p[i].y-p[0].y;
        dx=p[i].x-p[0].x;
        a[i].t=i;
        if (dx==0)
        {
            a[i].a=dy;
            a[i].inf=1;
        }
        else
        {
            a[i].a=dy;
            a[i].a/=dx;
            a[i].inf=0;
        }
        if (dy>=0 && dx>=0)
        {
            a[i].q=1;
        }
        else if (dy<=0 && dx>=0)
        {
            a[i].q=2;
        }
        else if (dy<=0 && dx<=0)
        {
            a[i].q=3;
        }
        else if (dy>=0 && dx<=0)
        {
            a[i].q=4;
        }
    }
    if (n==1) return;
    sort(a+1,a+n*2);
    /*for (int i=1;i<n*2;++i)
    {
        if (i>1) cerr<<(a[i]<a[i-1])<<endl;
        cerr<<a[i].t+1<<' '<<a[i].q<<endl;
    }*/
    int last;
    for (int i=1;i<n*2;++i)
    {
        if (a[i].t>=n) last=i;
    }
    for (int i=1;i<n*2;++i)
    {
        if (a[i].t>=n)
        {
            last=i;
            continue;
        }
        if (a[i].q==a[last].q || a[i].q==a[last].q%4+1)
        {
            cout<<a[last].t+1<<' '<<a[i].t+1<<'\n';
        }
        else
        {
            cout<<a[last].t+1<<' '<<a[i].t+1<<'\n';
            //while (1) {};
        }
    }
}

int main()
{
    cin.tie(0);
    ios::sync_with_stdio(0);

    input();
    solve();

    return 0;
}
