#include <cstdio>
#include <iostream>
#include <vector>
#include <utility>
#include <algorithm>

#define endl '\n'
#define prev abcd

using namespace std;

int n, cntBl, q, x, y, type, k, cntLeft=0, cntHV=0, qx, qy, smth;
string transf, prev="";

vector<pair<pair<int, int>, bool> > black;

bool cmp(pair<pair<int, int>, bool> ff, pair<pair<int, int>, bool> ss)
{
    if(ff.second==ss.second)
    {
        if(ff.first.first==ss.first.first) return ff.first.second<ss.first.second;
        return ff.first.first<ss.first.first;
    }
    return ff.second>ss.second;
}

int main ()
{
    //freopen("i1.txt", "r", stdin);
    ios::sync_with_stdio(false);cin.tie(NULL);
    cin>>n>>cntBl>>q;
    for(int i=0; i<cntBl; ++i)
    {
        cin>>x>>y;
        black.push_back({{x, y}, 1});
    }
    while(q--)
    {
        cin>>type;
        if(type==1)
        {
            cin>>transf;
            if(transf=="R") cntLeft+=3;
            else if(transf=="L") cntLeft++;
            else if(transf=="Q") cntLeft+=2;
            else if(transf=="H")
            {
                if(prev=="") prev="H";
                else if(prev=="V") cntHV++, prev="";
                else if(prev=="H") prev="";
            }
            else
            {
                if(prev=="") prev="V";
                else if(prev=="H") cntHV++, prev="";
                else if(prev=="V") prev="";
            }
        }
        else
        {
            cin>>x>>y;
            if(cntLeft)
            {
                cntLeft%=4;
                ////cout<<"LEFT FOR "<<x<<" "<<y<<endl;
                ////cout<<"cntLeft="<<cntLeft<<endl;
                qx=0;
                for(int i=0; i<(int)black.size(); ++i)
                {
                    if(!black[i].second) continue;
                    for(int j=0; j<cntLeft; ++j)
                    {
                        ////cout<<"from "<<black[i].first.first<<", "<<black[i].first.second;
                        smth=black[i].first.first;
                        black[i].first.first=n-black[i].first.second+1;
                        black[i].first.second=smth;
                        ////cout<<" to "<<black[i].first.first<<", "<<black[i].first.second<<endl;
                    }
                    if(black[i].first.first==x && black[i].first.second==y)
                    {
                        qx=1;
                        qy=i;
                    }
                }
                if(qx==1)
                {
                    ////cout<<"it is black so we make it white\n";
                    black[qy].second=false;
                }
                else
                {
                    ////cout<<"it is white so we make it black\n";
                    black.push_back({{x, y}, 1});
                }
                cntLeft=0;
                continue;
            }
            cntHV%=2;
            if(cntHV)
            {
                if(prev=="H")
                {
                    //cout<<"1, H\n";
                    qx=0;
                    for(int i=0; i<(int)black.size(); ++i)
                    {
                        if(!black[i].second) continue;
                        //cout<<"from "<<black[i].first.first<<", "<<black[i].first.second;
                        black[i].first.first=n-black[i].first.first+1;
                        //cout<<" to "<<black[i].first.first<<", "<<black[i].first.second<<endl;
                        if(black[i].first.first==x && black[i].first.second==y)
                        {
                            qx=1;
                            qy=i;
                        }
                    }
                    if(qx==1) black[qy].second=false;
                    else black.push_back({{x, y}, 1});
                    /*
                    3 1
                    2 4
                    */
                }
                else if(prev=="V")
                {
                    //cout<<"1, V\n";
                    qx=0;
                    for(int i=0; i<(int)black.size(); ++i)
                    {
                        if(!black[i].second) continue;
                        //cout<<"from "<<black[i].first.first<<", "<<black[i].first.second;
                        black[i].first.second=n-black[i].first.second+1;
                        //cout<<" to "<<black[i].first.first<<", "<<black[i].first.second<<endl;
                        if(black[i].first.first==x && black[i].first.second==y)
                        {
                            qx=1;
                            qy=i;
                        }
                    }
                    if(qx==1) black[qy].second=false;
                    else black.push_back({{x, y}, 1});
                }
                else
                {
                    //cout<<"1, 0\n";
                    qx=0;
                    for(int i=0; i<(int)black.size(); ++i)
                    {
                        if(!black[i].second) continue;
                        //cout<<"from "<<black[i].first.first<<", "<<black[i].first.second;
                        black[i].first.first=n-black[i].first.first+1;
                        black[i].first.second=n-black[i].first.second+1;
                        //cout<<" to "<<black[i].first.first<<", "<<black[i].first.second<<endl;
                        if(black[i].first.first==x && black[i].first.second==y)
                        {
                            qx=1;
                            qy=i;
                        }
                    }
                    if(qx==1) black[qy].second=false;
                    else black.push_back({{x, y}, 1});;
                    /*
                    4 3
                    2 1
                    */
                }
            }
            else
            {
                if(prev=="H")
                {
                    //cout<<"0, H\n";
                    qx=0;
                    for(int i=0; i<(int)black.size(); ++i)
                    {
                        if(!black[i].second) continue;
                        //cout<<"from "<<black[i].first.first<<", "<<black[i].first.second;
                        black[i].first.second=n-black[i].first.second+1;
                        //cout<<" to "<<black[i].first.first<<", "<<black[i].first.second<<endl;
                        if(black[i].first.first==x && black[i].first.second==y)
                        {
                            qx=1;
                            qy=i;
                        }
                    }
                    if(qx==1) black[qy].second=false;
                    else black.push_back({{x, y}, 1});
                }
                else if(prev=="V")
                {
                    //cout<<"0, V\n";
                    qx=0;
                    for(int i=0; i<(int)black.size(); ++i)
                    {
                        if(!black[i].second) continue;
                        //cout<<"from "<<black[i].first.first<<", "<<black[i].first.second;
                        black[i].first.first=n-black[i].first.first+1;
                        //cout<<" to "<<black[i].first.first<<", "<<black[i].first.second<<endl;
                        if(black[i].first.first==x && black[i].first.second==y)
                        {
                            qx=1;
                            qy=i;
                        }
                    }
                    if(qx==1) black[qy].second=false;
                    else black.push_back({{x, y}, 1});
                    /*
                    3 4
                    1 2
                    */
                }
                else
                {
                    //cout<<"0 0\n";
                    qx=0;
                    for(int i=0; i<(int)black.size(); ++i)
                    {
                        if(!black[i].second) continue;
                        if(black[i].first.first==x && black[i].first.second==y)
                        {
                            qx=1;
                            qy=i;
                            break;
                        }
                    }
                    if(qx==1) black[qy].second=false;
                    else black.push_back({{x, y}, 1});
                }
            }
            cntHV=0;
            prev="";
        }
    }
    if(cntLeft)
    {
        cntLeft%=4;
        ////cout<<"LEFT FINAL\n";
        ////cout<<"cntLeft="<<cntLeft<<endl;
        for(int i=0; i<(int)black.size(); ++i)
        {
            if(!black[i].second) continue;
            for(int j=0; j<cntLeft; ++j)
            {
                ////cout<<"from "<<black[i].first.first<<", "<<black[i].first.second;
                smth=black[i].first.first;
                black[i].first.first=n-black[i].first.second+1;
                black[i].first.second=smth;
                ////cout<<" to "<<black[i].first.first<<", "<<black[i].first.second<<endl;
            }
        }
    }
    cntHV%=2;
    if(cntHV)
    {
        if(prev=="H")
        {
            //cout<<"1 H\n";
            for(int i=0; i<(int)black.size(); ++i)
            {
                if(!black[i].second) continue;
                //cout<<"from "<<black[i].first.first<<", "<<black[i].first.second;
                black[i].first.first=n-black[i].first.first+1;
                //cout<<" to "<<black[i].first.first<<", "<<black[i].first.second<<endl;
            }
        }
        else if(prev=="V")
        {
            //cout<<"1 V\n";
            for(int i=0; i<(int)black.size(); ++i)
            {
                if(!black[i].second) continue;
                //cout<<"from "<<black[i].first.first<<", "<<black[i].first.second;
                black[i].first.second=n-black[i].first.second+1;
                //cout<<" to "<<black[i].first.first<<", "<<black[i].first.second<<endl;
            }
        }
        else
        {
            //cout<<"1 0\n";
            for(int i=0; i<(int)black.size(); ++i)
            {
                if(!black[i].second) continue;
                //cout<<"from "<<black[i].first.first<<", "<<black[i].first.second;
                black[i].first.first=n-black[i].first.first+1;
                black[i].first.second=n-black[i].first.second+1;
                //cout<<" to "<<black[i].first.first<<", "<<black[i].first.second<<endl;
            }
        }
    }
    else
    {
        if(prev=="H")
        {
            //cout<<"0 H\n";
            for(int i=0; i<(int)black.size(); ++i)
            {
                if(!black[i].second) continue;
                //cout<<"from "<<black[i].first.first<<", "<<black[i].first.second;
                black[i].first.second=n-black[i].first.second+1;
                //cout<<" to "<<black[i].first.first<<", "<<black[i].first.second<<endl;
            }
        }
        else if(prev=="V")
        {
            //cout<<"0 V\n";
            for(int i=0; i<(int)black.size(); ++i)
            {
                if(!black[i].second) continue;
                //cout<<"from "<<black[i].first.first<<", "<<black[i].first.second;
                black[i].first.first=n-black[i].first.first+1;
                //cout<<" to "<<black[i].first.first<<", "<<black[i].first.second<<endl;
            }
        }
    }
    cin>>k;
    sort(black.begin(), black.end(), cmp);
    for(int i=0; i<k; ++i)
    {
        cout<<black[i].first.first<<" "<<black[i].first.second<<endl;
    }
    return 0;
}
