#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;
int n, t, k, m;
vector<pair<int,int> > a;

struct {
    bool operator()(pair<int,int> a, pair<int,int> b)
    {
        if(a.first < b.first)return true;
        if(a.first > b.first)return false;

        if(a.second < b.second)return true;
        if(a.second > b.second)return false;
        return true;
    }
} sortVector;

void doOp(char op){
    switch(op){
        case 'R':
            for(int o = 0; o < t; o++){
                pair<int,int> p = a[o];
                a[o] = pair<int,int>(p.second,n-p.first+1);
            }
            break;
        case 'L':
            for(int o = 0; o < t; o++){
                pair<int,int> p = a[o];
                a[o] = pair<int,int>(n-p.second+1,p.first);
            }
            break;
        case 'Q':
            for(int o = 0; o < t; o++){
                pair<int,int> p = a[o];
                a[o] = pair<int,int>(n-p.second+1,n-p.first+1);
            }
            break;
        case 'V':
            for(int o = 0; o < t; o++){
                pair<int,int> p = a[o];
                a[o] = pair<int,int>(n-p.first+1,p.second);
            }
            break;
        case 'H':
            for(int o = 0; o < t; o++){
                pair<int,int> p = a[o];
                a[o] = pair<int,int>(p.first,n-p.second+1);
            }
            break;

    }
}

void switchColor(int tx, int ty){
    bool isBlack = false;
    int pos = -1;
    for(int o = 0; o < t; o++){
        if(a[o].first == tx & a[o].second == ty){
            isBlack = true;
            pos=o;
            break;
        }
    }

    if(isBlack){
        a.erase(a.begin() + pos, a.begin() + pos + 1);
        t--;
    }else{
        a.push_back(pair<int,int>(tx,ty));
        t++;
    }
}

int main()
{
    cin>>n>>t>>m;
    int tx,ty;
    for(int i = 0; i < t; i++){
        cin>>tx>>ty;
        a.push_back(pair<int,int>(tx,ty));
    }
    int type;
    char op;
    for(int i = 0; i < m; i++){
        cin>>type;
        if(type == 1){
            cin>>op;
            doOp(op);

        }else{
            cin>>tx>>ty;
            switchColor(tx,ty);
        }
        /*
        for(int i = 0; i < t; i++){
            cout<< a[i].first << " " << a[i].second << endl;
        }*/
    }

    sort(a.begin(), a.end(), sortVector);

    cin>>k;

    for(int i = 0; i < k; i++){
        cout<< a[i].first << " " << a[i].second << endl;
    }
    return 0;
}
