#include <iostream>
#include <algorithm>
#include <set>
using namespace std;
int n, t, k, m;

struct Comp{
    bool operator()(const pair<int,int> &a, const pair<int,int> &b) const
    {
        if(a.first < b.first)return true;
        if(a.first > b.first)return false;

        if(a.second < b.second)return true;
        if(a.second > b.second)return false;

        return false;
    }



};

/*bool operator==( const pair<int,int>& lhs, const pair<int,int>& rhs ){
        cout<<"Comp";
        return (lhs.first == rhs.first && lhs.second == rhs.second);

}*/

set< pair<int,int>, Comp > a;

void doOp(char op){
    int x,y;
    set< pair<int,int>, Comp > newa = set< pair<int,int>, Comp >();
    switch(op){
        case 'R':
            for (auto &p : a) {
                x = p.first;
                y = p.second;
                //a.erase(p);
                newa.insert(pair<int,int>(y,n-x+1));
            }
            break;
        case 'L':
            for (auto &p : a) {
                x = p.first;
                y = p.second;
                //a.erase(p);
                newa.insert(pair<int,int>(n-y+1,x));
            }
            break;
        case 'Q':
            for (auto &p : a) {
                x = p.first;
                y = p.second;
                //a.erase(p);
                newa.insert(pair<int,int>(n-y+1,n-x+1));
            }
            break;
        case 'V':
            for (auto &p : a) {
                x = p.first;
                y = p.second;
                //a.erase(p);
                newa.insert(pair<int,int>(n-x+1,y));
            }
            break;
        case 'H':
            for (auto &p : a) {
                x = p.first;
                y = p.second;
                //a.erase(p);
                newa.insert(pair<int,int>(x,n-y+1));
            }
            break;

    }
    //cout<<"Done"<<endl;
    a=newa;
}

void switchColor(int tx, int ty){
    pair<int,int> p = pair<int,int>(tx,ty);
    auto search = a.find(p);
    if(search != a.end()) {
        //cout<<"GOTEM";
        a.erase(p);
        t--;
    }else{
        a.insert(p);
        t++;
    }
}

int main()
{
    cin>>n>>t>>m;
    int tx,ty;
    for(int i = 0; i < t; i++){
        cin>>tx>>ty;
        a.insert(pair<int,int>(tx,ty));
    }
    int type;
    char op;
    for(int i = 0; i < m; i++){
        cin>>type;
        if(type == 1){
            cin>>op;
            doOp(op);

        }else{
            cin>>tx>>ty;
            switchColor(tx,ty);
        }

        /*for(auto &p : a){
            cout<< p.first << " " << p.second << endl;
        }*/
    }

    //sort(a.begin(), a.end(), sortSet);

    cin>>k;

    int cnt = 0;
    for(auto &p : a){
        cout<< p.first << " " << p.second << endl;
        cnt++;
        if(cnt == k)break;
    }
    return 0;
}
