#include<iostream>
#include<stdio.h>
#include<set>
using namespace std ;

#define MAXN 100007
int n , k ;
set < int > s[ 2 ][ MAXN ] ;

int rowid , colid ;

int rswap , cswap ;

int main ( ) {
    ios_base::sync_with_stdio ( false ) ;
    cin.tie ( NULL ) ;
    int m , q ;
    cin >> n >> m >> q ;
    int i ;
    rowid = 0 ;
    colid = 1 ;
    for ( i = 1 ; i <= m ; i ++ ) {
        int x , y ;
        cin >> x >> y ;
        s[ rowid ][ x ].insert ( y ) ;
        s[ colid ][ y ].insert ( x ) ;
    }
    rswap = cswap = 0 ;
    while ( q != 0 ) {
        q -- ;
        int type ;
        cin >> type ;
        if ( type == 1 ) {
            char c ;
            cin >> c ;
            if ( c == 'R' ) {
                swap ( rowid , colid ) ;
                swap ( rswap , cswap ) ;
                cswap ^= 1 ;
            }
            else if ( c == 'L' ) {
                swap ( rowid , colid ) ;
                swap ( rswap , cswap ) ;
                rswap ^= 1 ;
            }
            else if ( c == 'Q' ) {
                int aux = 2 ;
                while ( aux != 0 ) {
                    aux -- ;
                    swap ( rowid , colid ) ;
                    swap ( rswap , cswap ) ;
                    cswap ^= 1 ;
                }
            }
            else if ( c == 'V' ) {
                rswap ^= 1 ;
            }
            else {
                cswap ^= 1 ;
            }
        }
        else {
            int x , y ;
            cin >> x >> y ;
            int h = x ;
            if ( rswap == 1 ) { h = ( n - h + 1 ) ; }
            int src = y ;
            if ( cswap == 1 ) { src = ( n - src + 1 ) ; }
            set < int > :: iterator it = s[ rowid ][ h ].find ( src ) ;
            if ( it == s[ rowid ][ h ].end ( ) ) {
                s[ rowid ][ h ].insert ( src ) ;
                s[ colid ][ src ].insert ( h ) ;
            }
            else {
                s[ rowid ][ h ].erase ( it ) ;
                it = s[ colid ][ src ].find ( h ) ;
                s[ colid ][ src ].erase ( it ) ;
            }
        }
    }
    cin >> k ;
    int st , en , step ;
    if ( rswap == 0 ) {
        st = 1 ;
        en = n ;
        step = 1 ;
    }
    else {
        st = n ;
        en = 1 ;
        step = -1 ;
    }
    while ( k != 0 ) {
        for ( int i = st ; i != en ; i += step ) {
            int auxid = i ;
            if ( rswap == 1 ) { auxid = ( n - i + 1 ) ; }
            if ( k == 0 ) { break ; }
            if ( cswap == 0 ) {
                while ( 1 ) {
                    if ( k <= 0 ) { break ; }
                    if ( s[ rowid ][ i ].size ( ) == 0 ) { break ; }
                    set < int > :: iterator it = s[ rowid ][ i ].begin ( ) ;
                    cout << auxid << " " << (*it) << "\n" ;
                    s[ rowid ][ i ].erase ( it ) ;
                    k -- ;
                }
            }
            else {
                while ( 1 ) {
                    if ( k <= 0 ) { break ; }
                    if ( s[ rowid ][ i ].size ( ) == 0 ) { break ; }
                    set < int > :: iterator it = s[ rowid ][ i ].end ( ) ;
                    it -- ;
                    cout << auxid << " " << ( n - (*it) + 1 ) << "\n" ;
                    s[ rowid ][ i ].erase ( it ) ;
                    k -- ;
                }
            }
        }
    }
    return 0 ;
}


/**
3 3 6
1 1
3 2
3 3
1 R
1 H
2 2 1
1 V
2 1 3
1 H
2
**/
